package repub;

import java.util.HashMap;
import java.util.List;
import java.util.Vector;

/**
 * clique, used for role composition
 * 
 * @author Yingyi Bu
 *
 */
public class Clique {
	private List individuals = new Vector();

	/**
	 * using a list of people to initiate a clique
	 * @param ins
	 */
	public Clique(List ins) {
		individuals = ins;
	}

	public Clique() {

	}

	/**
	 * clear all individuals in a clique
	 *
	 */
	public void clear() {
		individuals.clear();
	}

	/**
	 * add an individual into the clique
	 * @param in
	 */
	public void addIndividual(Individual in) {
		individuals.add(in);
		in.setAvailble(false);
	}

	/**
	 * get all individuals in the clique
	 * @return
	 */
	public List getIndividuals() {
		return individuals;
	}

	/**
	 * check if the clique in a people list by hash
	 * 
	 * @param people
	 * @return
	 */
	public boolean checkIntesection(HashMap people) {
		for (int i = 0; i < individuals.size(); i++) {
			/**
			 * get the person
			 */
			Individual person = (Individual) individuals.get(i);
			/**
			 * check if all people of the clique in a special list
			 */
			if (people.get(new Integer(person.getPID())) == null)
				return false;
		}
		return true;
	}

	public int size() {
		return individuals.size();
	}

	/**
	 * transfer the string buffer to a string
	 */
	public String toString() {
		StringBuffer s = new StringBuffer("");
		for (int i = 0; i < individuals.size(); i++) {
			Individual person = (Individual) individuals.get(i);
			s.append(person.getPID() + " ");
		}
		return s.toString();
	}
}
