package repub;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.List;
import java.util.Random;
import java.util.Vector;

public class GenerateMicroData {

	public HashMap diseaseIDToName = new HashMap();

	public List diseases = new Vector();

	public void readMicroData(String dataset, HashMap diseaseToID) {
		/**
		 * set up all disease
		 */
		try {
			String tuple = "";
			// String[] results = new String[size];
			BufferedReader reader = new BufferedReader(new InputStreamReader(
					new FileInputStream(dataset)));

			int id = Constant.num_of_ps;
			/**
			 * read in all the tuples
			 */
			while ((tuple = reader.readLine()) != null) {

				String[] fields = tuple.split("!");
				// System.out.println(fields[0]);

				if (fields.length < 3) {
					System.out.println("errors!");
					System.out.println(fields[0]);
					continue;
				}

				int pid = 0;
				try {
					pid = Integer.parseInt(fields[1]);
				} catch (Exception e) {
					// e.printStackTrace();
					System.out.println("errors 2!");
					continue;
				}
				/**
				 * get the disease
				 */
				String dis = fields[2];

				/**
				 * find the id of BREAST CANCER
				 */
				if (dis.indexOf("BREAST CACNCER") != -1
						&& diseaseToID.get("BREAST CACNCER") == null) {
					diseaseToID.put(dis, new Integer(Constant.BREAST_CANCER));
					diseaseIDToName.put(new Integer(Constant.BREAST_CANCER),
							"BREAST CANCER");
					diseases.add("BREAST CANCER");
				}

				/**
				 * find the id of CAVITY CANCER
				 */
				else if (dis.indexOf("CIVITY CANCER") != -1
						&& diseaseToID.get("CIVITY CANCER") == null) {
					diseaseToID.put(dis, new Integer(Constant.CAVITY_CANCER));
					diseaseIDToName.put(new Integer(Constant.CAVITY_CANCER),
							"CAVITY CANCER");
					diseases.add("CAVITY CANCER");
				}

				/**
				 * find a diabete DIABETE
				 */
				else if (dis.indexOf("DIABETE") != -1
						&& diseaseToID.get("DIABETE") == null) {
					diseaseToID.put(dis, new Integer(Constant.DIABETE));
					diseaseIDToName.put(new Integer(Constant.DIABETE),
							"DIABETE");
					diseases.add("DIABETE");
				}

				/**
				 * assign each disease a ID to other diseases
				 */
				else if (diseaseToID.get(dis) == null) {
					diseaseToID.put(dis, new Integer(id));
					diseaseIDToName.put(new Integer(id), dis);
					diseases.add(dis);
					id++;
				}
				;
			}
			// System.out.println(dis_no);
			reader.close();

		} catch (Exception e) {
			e.printStackTrace();
			// return null;
		}
	}

	public void generateMicroData(String target, String dataset) {

		Random rd = new Random(System.currentTimeMillis());

		int range = diseases.size();
		
		/**
		 * set up all disease
		 */
		try {
			String tuple = "";
			BufferedReader reader = new BufferedReader(new InputStreamReader(
					new FileInputStream(dataset)));

			PrintWriter writer = new PrintWriter(new OutputStreamWriter(
					new FileOutputStream(target)));

			int number = 1;
			/**
			 * read in all the tuples
			 */
			while ((tuple = reader.readLine()) != null) {

				String[] fields = tuple.split("!");
				// System.out.println(fields[0]);

				if (fields.length < 3) {
					System.out.println("errors!");
					System.out.println(fields[0]);
					continue;
				}

				String dis = fields[2];

				int change = Math.abs(rd.nextInt()) % 10;

				/**
				 * if change = 0, then we need to have some changes
				 */
				if (change == 0 && dis.indexOf("CANCER") < 0
						&& dis.indexOf("DIABETE") < 0) {

					int pos = Math.abs(rd.nextInt()) % range;
					/**
					 * randomly select a distance
					 */
					dis = (String) diseases.get(pos);
				}
				/**
				 * allow change
				 */
				if (change != 1) {
					tuple = fields[0] + "!" + fields[1] + "!" + dis;
					writer.println(tuple);
					number++;
				}

				/**
				 * put all the permanent disease individuals
				 */

				if (number > Constant.TESTSIZE)
					break;
			}

			writer.flush();
			reader.close();
			writer.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		GenerateMicroData gn = new GenerateMicroData();
		HashMap hm = new HashMap();
		gn.readMicroData("data/re-action.txt", hm);
		// gn.generateMicroData("microdata/T" + 1 + ".txt",
		// "data/re-action.txt");
		for (int i = 0; i < 20; i++) {
			gn.generateMicroData("microdata/T" + (i + 2) + ".txt",
					"data/re-action.txt");
		}
	}
}
