package repub;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.List;
import java.util.Random;

public class GenerateRL {

	public void generateRLData(String target) {

		List rlist = null;
		/**
		 * set up all disease
		 */
		try {
			try {
				ObjectInputStream input = new ObjectInputStream(
						new FileInputStream(Constant.internalList));
				rlist = (List) input.readObject();

				AGroup ag = new AGroup(rlist);
				float[] lower = ag.getLower();
				float[] upper = ag.getUpper();

				PrintWriter writer = new PrintWriter(new OutputStreamWriter(
						new FileOutputStream(target)));
				Random rd = new Random(System.currentTimeMillis());

				/**
				 * generate new RL
				 */
				for (int i = 0; i < rlist.size(); i++) {
					Individual person = (Individual) rlist.get(i);
					int change = Math.abs(rd.nextInt()) % 50;
					if (change == 0) {
						float[] QID = new float[Constant.DIM];
						for (int j = 0; j < QID.length; j++) {
							QID[j] = lower[j] + rd.nextFloat()
									* (upper[j] - lower[j]);
						}
						person.setQID(QID);
					}

					/**
					 * randomly decide if print the tuple
					 */
					int put = Math.abs(rd.nextInt()) % 50;
					if (put != 0) {
						writer.println(person);
					}
				}
				/**
				 * let
				 */
				input.close();
				writer.close();
			} catch (Exception e) {
				e.printStackTrace();
			}

		} catch (Exception e) {
			e.printStackTrace();
			// return null;
		}

	}

	public static void main(String[] args) {
		GenerateRL gn = new GenerateRL();
		for (int i = 0; i < 100; i++) {
			gn.generateRLData("RL/RL" + (i + 2) + ".txt");
		}
	}
}
