package repub;

import java.io.Serializable;
import java.util.List;
import java.util.Vector;

/**
 * cohort of individuals
 * 
 * @author Administrator
 * 
 */
public class ICohort implements Serializable {

	int sensitiveValue = 0;

	int id = 0;

	int size = 0;

	/*
	 * list of pointers to all individuals :owners
	 */
	private List individuals = new Vector();

	/**
	 * the constructor of the Cohort
	 * 
	 * @param s
	 * @param number
	 */
	public ICohort(int s, int number) {
		sensitiveValue = s;

		/**
		 * cohort ID
		 */
		id = number;
	}

	/**
	 * see if a person is contained in a cohort
	 * 
	 * @param p
	 * @return
	 */
	public boolean contain(Individual p) {
		for (int i = 0; i < individuals.size(); i++) {
			Individual person = (Individual) individuals.get(i);
			if (person.equal(p)) {
				return true;
			}
		}
		return false;
	}

	/**
	 * put a individual into the cohort
	 * 
	 * @param in:
	 *            the pointer to an inidivudal
	 */
	public void put(Individual in) {
		if (!this.contain(in))
			individuals.add(in);
	}

	public List getIndividuals() {
		return individuals;
	}

	/**
	 * remove individual p from the individual list
	 * 
	 * @param p
	 */
	public void removeIndividual(Individual p) {
		individuals.remove(p);
	}
}
