package repub;

import java.io.Serializable;
import java.util.List;
import java.util.Vector;

public class SContainer implements Serializable {

	private List individuals = new Vector();

	private int senValue = 0;

	/**
	 * initialization, also, set the sensitive value of container
	 * 
	 * @param s
	 */
	public SContainer(int s, List ins) {
		senValue = s;
		individuals = ins;
	}

	/**
	 * get the higher values of Anonymized Group
	 * 
	 * @return
	 */
	public float[] getLower() {
		float lower[][] = new float[individuals.size()][];
		for (int i = 0; i < individuals.size(); i++) {
			Individual in = (Individual) individuals.get(i);
			lower[i] = in.getQID();
		}

		float value[] = new float[Constant.DIM];
		for (int i = 0; i < value.length; i++)
			value[i] = 9999999;
		for (int j = 0; j < lower.length; j++) {
			for (int k = 0; k < Constant.DIM; k++) {
				if (value[k] > lower[j][k])
					value[k] = lower[j][k];
			}
		}
		return value;
	}

	/**
	 * get the lower values of Anonymized Group
	 * 
	 * @return
	 */
	public float[] getUpper() {
		float upper[][] = new float[individuals.size()][];
		for (int i = 0; i < individuals.size(); i++) {
			Individual in = (Individual) individuals.get(i);
			upper[i] = in.getQID();
		}

		float value[] = new float[Constant.DIM];
		for (int i = 0; i < value.length; i++)
			value[i] = 0;
		for (int j = 0; j < upper.length; j++) {
			for (int k = 0; k < Constant.DIM; k++) {
				if (value[k] < upper[j][k])
					value[k] = upper[j][k];
			}
		}
		/**
		 * return the upper bound
		 */
		return value;

	}

	/**
	 * add individuals into the container
	 * 
	 * @param in
	 */
	public void addInidividual(Individual in) {
		individuals.add(in);
	}

	/**
	 * get individuals as a list
	 * 
	 * @return a list of individuals
	 */
	public List getIndividuals() {
		return individuals;
	}

	public SContainer[] compress() {
		return null;
	}

	public Boundary getBoundary() {
		return null;
	}

	/**
	 * remove the person from individual list
	 * 
	 * @param person
	 */
	public void remove(Individual person) {
		individuals.remove(person);
	}

	/**
	 * get the next individual
	 * 
	 * @return
	 */
	public Individual getNext() {
		if (individuals.size() > 0)
			return (Individual) individuals.get(0);
		else
			return null;
	}

	/**
	 * get the next clean individual from the container
	 * 
	 * @return
	 */
	public Individual getNextBuddy(int dis) {
		int i = 0;
		Individual person = null;
		do {
			person = (Individual) individuals.get(i);
			i++;
		} while (person.getRole(dis) != Constant.BUDDY
				&& i < individuals.size());
		if (i < individuals.size())
			return person;
		else
			return null;
	}

	// /**
	// * split all individuals
	// *
	// * @param dis
	// */
	// public void splitAll(int dis) {
	//
	// List cohorts = new Vector();
	// /**
	// * add the person into individual list
	// */
	// for (int i = 0; i < individuals.size(); i++) {
	// Individual person = (Individual) individuals.get(i);
	// cohorts.add(person);
	// }
	//
	// if (cohorts.size() == 1) {
	// for
	//		}
	//	}
}
