package repub;

import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;

public class TestC {

	public static void main(String[] args) {
		try {
			TestError.initialTestEnvironment();
			/**
			 * restore L to 3, and test for different parameter c
			 */
			Constant.L = 3;
			/**
			 * the two files for parameter C, the size of containers
			 */
			PrintWriter time = new PrintWriter(new OutputStreamWriter(
					new FileOutputStream("timeC.txt")));
			PrintWriter perturbation = new PrintWriter(new OutputStreamWriter(
					new FileOutputStream("replaceC.txt")));
			PrintWriter error = new PrintWriter(new OutputStreamWriter(
					new FileOutputStream("errorC.txt")));

			/**
			 * reset accumulate perturbation rate to zero
			 */
			Generalization.resetPerturbation();
			/**
			 * test for different parameter C
			 */
			for (int c = 3; c <= 8; c += 2) {
				Constant.CONTAINER_SIZE = c;
				File folder = new File(".//publicationC"
						+ Constant.CONTAINER_SIZE);
				folder.mkdir();

				/**
				 * initialize a generalization
				 */
				Generalization gn = new Generalization(
						"../publication/composition" + 2 + ".txt", 2);
				gn.readStartRLData("../data/REPORTS.TXT");

				SensitiveValue.readMicroData("../data/re-action.txt");

				time.print(c);
				perturbation.print(c);
				error.print(c);

				Generalization.resetPerturbation();
				/**
				 * publish data for 19 rounds
				 */
				for (int i = 2; i < 21; i++) {

					long start = System.currentTimeMillis();
					gn = new Generalization("publicationC"
							+ Constant.CONTAINER_SIZE + "/composition" + i
							+ ".txt", i);

					gn.loadRLData();

					gn.readMicroData("../microdata/T" + i + ".txt");
					gn.divideRL();

					gn.topDownPartition();

					/**
					 * update all signatures of individuals updated in
					 * topDownPartition()
					 */
					// gn.updateAllSignatures();
					long end = System.currentTimeMillis();

					if (i % 4 == 0) {
						time.print(" " + (end - start));
						perturbation.print(" " + gn.getPerturbationRate());
						error.print(" "
								+ TestError.unitTestError("../microdata/T" + i
										+ ".txt", "publicationC" + c
										+ "/composition" + i + ".txt"));

						time.flush();
						perturbation.flush();
						error.flush();
					}

					/**
					 * delete the publication
					 */
					(new File("publicationC" + c + "/composition" + i + ".txt"))
							.delete();
				}
				time.println();
				perturbation.println();
				error.println();
			}

			time.close();
			perturbation.close();
			error.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
