package repub;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.List;
import java.util.Random;
import java.util.Vector;

public class TestError {

	public static void main(String[] args) {
		testError();
	}

	public static void testError() {

		try {
			PrintWriter error = new PrintWriter(new OutputStreamWriter(
					new FileOutputStream("Lerror.txt")));

			TestError.readStartRLData("../data/REPORTS.TXT");
			SensitiveValue.readMicroData("../data/re-action.txt");

			for (int l = 3; l <= 8; l += 2) {
				/**
				 * for each publication do it
				 */
				for (int i = 2; i < 21; i++) {
					List tuples = readMicro("../microdata/T" + i + ".txt");
					List uts = readPublication("publicationL" + l
							+ "/composition" + i + ".txt");
					float res = evaluateQuery(tuples, uts);
					error.println(l + " " + i + " " + res);
					error.flush();
				}
			}

			error.flush();
			error.close();
			error = new PrintWriter(new OutputStreamWriter(
					new FileOutputStream("Cerror.txt")));
			for (int c = 3; c <= 8; c += 2) {
				for (int i = 2; i < 21; i++) {
					List tuples = readMicro("../microdata/T" + i + ".txt");
					List groups = readPublication("publicationC" + c
							+ "/composition" + i);
					float res = evaluateQuery(tuples, groups);
					error.println(c + " " + i + " " + res);
					error.flush();
				}
			}
			error.flush();
			error.close();
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	public static void initialTestEnvironment() {
		TestError.readStartRLData("../data/REPORTS.TXT");
		SensitiveValue.readMicroData("../data/re-action.txt");
	}

	public static double unitTestError(String micro, String anonym) {

		List tuples = readMicro(micro);
		List uts = readPublication(anonym);
		float res = evaluateQuery(tuples, uts);
		
		return res;
	}

	/**
	 * read micro data of tuples, return a list of tuples
	 * 
	 * @param file
	 * @return
	 */
	public static List readMicro(String file) {
		List tuples = new Vector();
		/**
		 * set up all diseases
		 */
		try {
			String tuple = "";
			int size = 0;

			BufferedReader reader = new BufferedReader(new InputStreamReader(
					new FileInputStream(file)));
			System.gc();
			SensitiveValue.readMicroData("../data/re-action.txt");

			int num_of_tuples = 0;
			/**
			 * read in all the tuples
			 */
			while ((tuple = reader.readLine()) != null) {

				String[] fields = tuple.split("!");

				if (fields.length < 3) {
					System.out.println("errors!");
					System.out.println(fields[0]);
					continue;
				}

				int pid = 0;
				try {
					pid = Integer.parseInt(fields[1]);
				} catch (Exception e) {
					e.printStackTrace();
					System.out.println("errors 2!");
					continue;
				}
				/**
				 * get the disease
				 */
				String dis = fields[2].trim();

				Individual p = (Individual) voters.get(new Integer(pid));

				Tuple tu = null;

				if (p == null) {
					System.out.println("null person: no entry in RL! ");
					continue;
				}

				if (dis.indexOf("BREAST CANCER") >= 0) {
					tu = new Tuple(p.getQID(), new Integer(
							Constant.BREAST_CANCER));
				}
				/**
				 * set the holder of civity cancer
				 */
				else if (dis.indexOf("CAVITY CANCER") >= 0) {
					tu = new Tuple(p.getQID(), new Integer(
							Constant.CAVITY_CANCER));
				}
				/**
				 * find a diabete DIABETE
				 */
				else if (dis.indexOf("DIABETE") >= 0) {
					tu = new Tuple(p.getQID(), new Integer(Constant.DIABETE));
				}
				/**
				 * set other disease
				 */
				else {
					Integer diseaseID = (Integer) SensitiveValue.diseaseToID
							.get(dis);
					tu = new Tuple(p.getQID(), diseaseID);
				}
				tuples.add(tu);
				num_of_tuples++;
			}
			System.out.println("number of tuples: " + num_of_tuples);
			reader.close();
			return tuples;
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}

	static HashMap voters = new HashMap();

	static List rlist = new Vector();

	/**
	 * read the published data Utuples
	 * 
	 * @param file
	 * @return
	 */
	public static List readPublication(String file) {
		List utuples = new Vector();
		/**
		 * set up all diseases
		 */
		try {
			String tuple = "";

			BufferedReader reader = new BufferedReader(new InputStreamReader(
					new FileInputStream(file)));
			System.gc();
			SensitiveValue.readMicroData("../data/re-action.txt");

			int num_of_tuples = 0;
			/**
			 * read in all the tuples
			 */
			while ((tuple = reader.readLine()) != null) {

				String[] fields = tuple.split(" ");

				String[] range1 = fields[2].split("-");

				String[] range2 = fields[3].split("-");

				String[] range3 = fields[4].split("-");

				float lower[] = new float[Constant.DIM];

				float upper[] = new float[Constant.DIM];
				try {

					lower[0] = (float) Double.parseDouble(range1[0]);

					lower[1] = (float) Double.parseDouble(range2[0]);

					lower[2] = (float) Double.parseDouble(range3[0]);

					upper[0] = (float) Double.parseDouble(range1[1]);

					upper[1] = (float) Double.parseDouble(range2[1]);

					upper[2] = (float) Double.parseDouble(range3[1]);
				} catch (Exception e) {
					System.out.println("input error");
					continue;
				}

				String disease = fields[5];

				for (int i = 6; i < fields.length; i++)
					disease = disease + " " + fields[i];

				Integer dis = (Integer) SensitiveValue.diseaseToID.get(disease);

				if (dis == null)
					System.out.println("null disease" + disease);
				UTuple tu = new UTuple(dis, upper, lower);

				utuples.add(tu);
				num_of_tuples++;
			}
			System.out.println("number of tuples: " + num_of_tuples);
			reader.close();
			return utuples;
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}

	/**
	 * evaluate aggregate count query
	 * 
	 * @param tuples
	 * @param groups
	 * @return
	 */
	public static float evaluateQuery(List tuples, List uts) {
		float start_age = 15;
		float start_weight = 60;
		float start_height = 130;
		float range_age = 50;
		float range_weight = 60;
		float range_height = 60;
		Random rd = new Random(System.currentTimeMillis());

		float accuracy = 0;

		int count1 = 0;
		int count2 = 0;

		for (int round = 1; round < 5000; round++) {
			float age1 = start_age + rd.nextFloat() * range_age;
			float age2 = start_age + rd.nextFloat() * range_age;

			// age1 = -1000;
			// age2 = 1000;

			float age_low = 0;
			float age_high = 0;
			if (age1 > age2) {
				age_high = age1;
				age_low = age2;
			} else {
				age_high = age2;
				age_low = age1;
			}

			float weight1 = start_weight + rd.nextFloat() * range_weight;
			float weight2 = start_weight + rd.nextFloat() * range_weight;

			// weight1 = -1000;
			// weight2 = 1000;

			float weight_low = 0;
			float weight_high = 0;
			if (weight1 > weight2) {
				weight_high = weight1;
				weight_low = weight2;
			} else {
				weight_high = weight2;
				weight_low = weight1;
			}

			float height1 = start_height + rd.nextFloat() * range_height;
			float height2 = start_height + rd.nextFloat() * range_height;

			// height1 = -1000;
			// height2 = 1000;

			float height_low = 0;
			float height_high = 0;
			if (height1 > height2) {
				height_high = height1;
				height_low = height2;
			} else {
				height_high = height2;
				height_low = height1;
			}

			// System.out.println("query: " + age_low + "-" + age_high + " "
			// + weight_low + "-" + weight_high + " " + height_low + "-"
			// + height_high);

			int disease = Math.abs(rd.nextInt()) % 400;
			Integer dis = new Integer(disease);

			int realCount = 0;
			for (int i = 0; i < tuples.size(); i++) {
				Tuple tuple = (Tuple) tuples.get(i);
				if (tuple.dis.equals(dis) && tuple.qid[0] > age_low
						&& tuple.qid[0] < age_high && tuple.qid[1] > weight_low
						&& tuple.qid[1] < weight_high
						&& tuple.qid[2] > height_low
						&& tuple.qid[2] < height_high)
					realCount++;
			}

			int anonyCount = 0;
			for (int i = 0; i < uts.size(); i++) {
				UTuple ut = (UTuple) uts.get(i);
				// if (ut.upper[0] - ut.lower[0] > 80
				// || ut.upper[1] - ut.lower[1] > 80
				// || ut.upper[2] - ut.lower[2] > 80)
				// continue;
				if (ut.dis.equals(dis)
						&& (((ut.lower[0] > age_low && ut.lower[0] < age_high) || (ut.upper[0] < age_high && ut.upper[0] > age_low))
								&& ((ut.lower[1] > weight_low && ut.lower[1] < weight_high) || (ut.upper[1] < weight_high && ut.upper[1] > weight_low)) && ((ut.lower[2] > height_low && ut.lower[2] < height_high) || (ut.upper[2] < height_high && ut.upper[2] > height_low))))
					anonyCount++;
			}

			if (realCount == 0 && anonyCount == 0)
				accuracy += 1;

			count1 += realCount;
			count2 += anonyCount;
			// System.out.println(realCount + " " + anonyCount);
			if (realCount > anonyCount && realCount != 0)
				accuracy += (float) anonyCount / (float) realCount;
			else if (anonyCount != 0)
				accuracy += (float) realCount / (float) anonyCount;

		}
		// System.out.println("real count: " + count1);
		// System.out.println("real count: " + count2);
		// if (count1 > count2)
		// accuracy = count2 / count1;
		// else
		// accuracy = count1 / count2;
		System.out.println("accuracy: " + accuracy);
		accuracy = accuracy / 5000;
		return accuracy;
	}

	public static void readStartRLData(String dataset) {
		rlist.clear();
		voters.clear();
		try {
			String tuple = "";
			System.gc();

			BufferedReader reader = new BufferedReader(new InputStreamReader(
					new FileInputStream(dataset)));
			int i = 0;
			/**
			 * read in all the tuples
			 */
			int count = 0;
			while ((tuple = reader.readLine()) != null) {
				// results[i] = tuple;
				Individual p = parseRLData(tuple);

				if (p != null) {
					// System.out.println(p);
					count++;
					if (voters.get(new Integer(p.getPID())) == null) {
						voters.put(new Integer(p.getPID()), p);
						rlist.add(p);
					}
				}
				i++;
			}
			// System.out.println(count);
			reader.close();
		} catch (Exception e) {
			e.printStackTrace();
			// return null;
		}

	}

	public static Individual parseRLData(String person) {
		Random rd = new Random(System.currentTimeMillis());
		/**
		 * setup the voter's list
		 */
		// for (int i = 0; i < people.length; i++) {
		String[] fields = person.split("!");
		// for (int i = 0; i < fields.length; i++)
		// System.out.print(fields[i] + " ");
		// System.out.println();

		try {
			if (fields[0].equals(""))
				return null;
			int pid = Integer.parseInt(fields[0]);
			if (fields[4].equals("-") || fields[6].equals("-")
					|| fields[7].equals("-"))
				return null;
			float age = Float.parseFloat(fields[3]);
			float weight = Float.parseFloat(fields[6]);
			float height = Float.parseFloat(fields[7]);
			float[] qid = new float[Constant.DIM];

			qid[0] = age;
			qid[1] = weight;
			qid[2] = height;

			Individual p = new Individual(pid, qid);

			/**
			 * put the one into voter list
			 */
			// voters.put(new Integer(pid), p);
			// int put = Math.abs(rd.nextInt()) % 10;
			// if (put == 0)
			// peopleList.add(p);
			// rlist.add(p);
			return p;
		} catch (Exception e) {
			// e.printStackTrace();
			return null;
		}
		// }
	}

}
