package repub;

import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;

public class TestK {
	public static void main(String[] args) {
		try {
			TestError.initialTestEnvironment();

			Constant.L = 3;
			Constant.CONTAINER_SIZE = 3;

			/**
			 * the result of time and perturbation rate
			 */
			PrintWriter time = new PrintWriter(new OutputStreamWriter(
					new FileOutputStream("timeK.txt")));
			PrintWriter perturbation = new PrintWriter(new OutputStreamWriter(
					new FileOutputStream("replaceK.txt")));
			PrintWriter error = new PrintWriter(new OutputStreamWriter(
					new FileOutputStream("errorK.txt")));

			Generalization.resetPerturbation();

			/**
			 * size of participation knowledge
			 */
			for (int K = 3; K <= 8; K += 2) {
				Constant.CONTAINER_SIZE = Constant.CONTAINER_SIZE + K;

				File folder = new File(".//publicationK"
						+ K);

				folder.mkdir();

				Generalization gn = new Generalization(
						"../publication/composition" + 2 + ".txt", 2);
				gn.readStartRLData("../data/REPORTS.TXT");

				SensitiveValue.readMicroData("../data/re-action.txt");

				
				
				time.print(K);
				perturbation.print(K);
				error.print(K);

				Generalization.resetPerturbation();
				
				for (int i = 2; i < 21; i++) {
					long start = System.currentTimeMillis();
					gn = new Generalization("publicationK"
							+ K + "/composition" + i
							+ ".txt", i);

					
					gn.loadRLData();
					gn.readMicroData("../microdata/T" + i + ".txt");
					gn.divideRL();
					
					gn.topDownPartition();

					/**
					 * update all signatures of individuals updated in top down
					 * partition
					 */
					// gn.updateAllSignatures();
					long end = System.currentTimeMillis();

					/**
					 * print the running time and perturbation
					 */
					if (i % 4 == 0) {
						time.print(" " + (end - start));
						perturbation.print(" " + gn.getPerturbationRate());
						error.print(" "
								+ TestError.unitTestError("../microdata/T" + i
										+ ".txt", "publicationK" + K
										+ "/composition" + i + ".txt"));
						time.flush();
						perturbation.flush();
						error.flush();
					}
					/**
					 * delete the publication
					 */
					(new File("publicationK" + K + "/composition" + i + ".txt"))
							.delete();
				}
				time.println();
				perturbation.println();
				error.println();
			}

			time.close();
			perturbation.close();
			error.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
