package repub;

import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;

public class TestL {

	public static void main(String[] args) {
		try {
			TestError.initialTestEnvironment();
			/**
			 * report the time used for each generalization process
			 */
			PrintWriter time = new PrintWriter(new OutputStreamWriter(
					new FileOutputStream("timeL.txt")));
			/**
			 * report the perturbation rate for each generalization process
			 */
			PrintWriter perturbation = new PrintWriter(new OutputStreamWriter(
					new FileOutputStream("replaceL.txt")));

			/**
			 * report the perturbation rate for each generalization process
			 */
			PrintWriter error = new PrintWriter(new OutputStreamWriter(
					new FileOutputStream("errorL.txt")));

			/**
			 * reset perturbation rate to zero
			 */
			Generalization.resetPerturbation();

			/**
			 * change L and generate
			 */
			for (int l = 3; l <= 8; l = l + 2) {
				/**
				 * set the parameter L for L-scarcity
				 */
				Constant.L = l;
				Generalization gn = new Generalization(
						"../publication/composition" + 2 + ".txt", 2);
				gn.readStartRLData("../data/REPORTS.TXT");

				time.print(l);
				perturbation.print(l);
				error.print(l);

				/**
				 * read microdata to initiate sensitive values
				 */
				SensitiveValue.readMicroData("../data/re-action.txt");

				Generalization.resetPerturbation();
				/**
				 * publish 19 rounds
				 */
				for (int i = 2; i < 21; i++) {
					long start = System.currentTimeMillis();
					File folder = new File(".//publicationL" + Constant.L);

					folder.mkdir();

					gn = new Generalization("publicationL" + l + "/composition"
							+ i + ".txt", i);

					gn.loadRLData();

					gn.readMicroData("../microdata/T" + i + ".txt");
					gn.divideRL();
					
					gn.topDownPartition();

					/**
					 * update all signatures of individuals
					 */
					// gn.updateAllSignatures();
					long end = System.currentTimeMillis();

					if (i % 4 == 0) {
						time.print(" " + (end - start));
						perturbation.print(" " + gn.getPerturbationRate());
						error.print(" "
								+ TestError.unitTestError("../microdata/T" + i
										+ ".txt", "publicationL" + l
										+ "/composition" + i + ".txt"));

						time.flush();
						perturbation.flush();
						error.flush();
					}

					/**
					 * delete the publication
					 */
					(new File("publicationL" + l + "/composition" + i + ".txt"))
							.delete();
				}
				time.println();
				perturbation.println();
				error.println();
			}
			time.close();
			perturbation.close();
			error.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
